require "defines"
require("config")

function add_research(player,research_name)
	for k,v in pairs(player.force.technologies[research_name].prerequisites) do
		if not v.researched then add_research(player,v.name) end
	end
	local isInList = false
	for i,v in ipairs(global.researchQ[player.force.name]) do
		if v == research_name then isInList=true end
	end
	if not isInList and not player.force.technologies[research_name].researched then
		table.insert(global.researchQ[player.force.name],research_name)
	end
end

function remove_research(player,research_name)	
	for i,v in ipairs(global.researchQ[player.force.name]) do
		if v == research_name then 
			research_index = i 
			break
		end
	end
	table.remove(global.researchQ[player.force.name],research_index)
	for i,v1 in ipairs(global.researchQ[player.force.name]) do
		for k,v2 in pairs(player.force.technologies[v1].prerequisites) do
			local isInQueue = false
			for j = 1,i do
				if v2.name == global.researchQ[player.force.name][j] then 
					isInQueue = true 
					break
				end
			end
			if not isInQueue then remove_research(player,v1) end
		end
	end
end

function up(player,var)
	local research_index = nil
	local research_name = nil
	if tonumber(var)then
		research_index = var
		research_name = global.researchQ[player.force.name][var]
	else
		research_name = var
		for i,v in ipairs(global.researchQ[player.force.name]) do
			if v == var then research_index = i end
		end
	end	
	if research_index > 1 then
		local canMoveUp = true
		for k,v in pairs(player.force.technologies[research_name].prerequisites) do
			if v.name == global.researchQ[player.force.name][research_index-1] then canMoveUp = false end
		end
		if canMoveUp then
			table.remove(global.researchQ[player.force.name],research_index)
			table.insert(global.researchQ[player.force.name],research_index-1,research_name)
		end
	end
end

function down(player,var)
	local research_index = nil
	local research_name = nil
	if tonumber(var)then
		research_index = var
		research_name = global.researchQ[player.force.name][var]
	else
		research_name = var
		for i,v in ipairs(global.researchQ[player.force.name]) do
			if v == var then research_index = i end
		end
	end	
	if research_index < #global.researchQ[player.force.name] then
		local canMoveDown = true
		for k,v in pairs(player.force.technologies[global.researchQ[player.force.name][research_index+1]].prerequisites) do
			if v.name == research_name then canMoveDown = false end
		end
		if canMoveDown then
			table.remove(global.researchQ[player.force.name],research_index)
			table.insert(global.researchQ[player.force.name],research_index+1,research_name)
		end
	end
end

function updateQ(player)
	if player.gui.center.Q.current_q.list then player.gui.center.Q.current_q.list.destroy() end
	local list = player.gui.center.Q.current_q.add{type="flow", name="list", style="rq-flow", direction="vertical"}
	if not global.researchQ[player.force.name][1] then
		list.add{type="label",name="empty", caption = "No research queued"}
	else
		for i,v in ipairs(global.researchQ[player.force.name]) do
			if global.offset[player.index] < i and i <= (rq.q_per_page+global.offset[player.index]) then
				local frame = list.add{type="frame", name="rq"..v.."frame", style="rq-frame"}
				local icon = frame.add{type="frame", name = "rq"..v.."icon", style = "rq-"..v.."large"}
				local description = frame.add{type="frame", name = "rq"..v.."description", style = "tooltip_frame_style", direction = "vertical"}
				description.style.minimal_width = 175
				local name = description.add{type="label",name = "rq"..v.."name", caption = player.force.technologies[v].localised_name, style = "description_label_style"}
				local buttons = frame.add{type="table", name = "rq"..v.."buttons", style = "slot_table_style", colspan=1}
				local upbutton = buttons.add{type="button", name = "rq".."upbutton"..v, style = "rq-up-button"}
				local cancelbutton = buttons.add{type="button", name = "rq".."cancelbutton"..v, style = "rq-cancel-button"}
				local downbutton = buttons.add{type="button", name = "rq".."downbutton"..v, style = "rq-down-button"}
			elseif i == global.offset[player.index] then
				local upbutton = list.add{type="button", name = "rqscrollup", style = "rq-up-button"}
			elseif i > rq.q_per_page+global.offset[player.index] then
				local downbutton = list.add{type="button", name = "rqscrolldown", style = "rq-down-button"}
				break
			end
		end
	end
end

function drawGrid(player)
	local index = player.index
	if not player.gui.center.Q.add2q.options then 
		local options = player.gui.center.Q.add2q.add{type="table", name = "options", style = "slot_table_style", colspan = rq.research_table_width}
		local text = options.add{type = "checkbox", name = "rqtext", style = "rq-text-checkbox", state=global.showIcon[index]}
		local scienceDone = options.add{type = "checkbox", name = "rqscience", style = "rq-scienceDone-checkbox", state= not global.showResearched[index]}
	end	
	if player.gui.center.Q.add2q.add2q_table then player.gui.center.Q.add2q.add2q_table.destroy() end
	if global.showIcon[index] then colSpan = rq.research_table_width else colSpan =  math.floor(rq.research_table_width/2) end
	local current_frame = player.gui.center.Q.add2q.add{type="table", name = "add2q_table", style = "slot_table_style",colspan = colSpan}
	local background = nil
	for k,v in pairs(player.force.technologies) do
		if v.enabled then
			if (not v.researched or global.showResearched[index]) and (global.show_higher_tiers[index] or not v.upgrade or not all(v.prerequisites,"upgrade") or any(v.prerequisites,"researched") or matches(v.prerequisites,"name",global.researchQ[player.force.name])) then
				
				if v.researched then 
					background1 = "rq-done-frame"
					background2 = "rq-done-button"
				else 
					background1 = "rq-available-frame" 
					background2 = "rq-available-button"
				end
				for i,q in ipairs(global.researchQ[player.force.name]) do
					if v.name == q then 
						background1 = "rq-inq-frame" 
						background2 = "rq-inq-button"
					end
				end
				
				if global.showIcon[index] then
					local frame1 = current_frame.add{type="frame", name="rq"..v.name.."background_frame", style=background1}
					local frame2 = frame1.add{type="frame", name = v.name.."frame", style = "rq-"..v.name}
					local caption = string.match(v.name,"%-%d+")
					if caption then caption = string.gsub(caption,"%-"," ") end
					local frame3 = frame2.add{type="label", name = v.name.."label", style = "rq-label", caption = caption}
					local frame4 = frame3.add{type="button", name = "rq-add"..v.name, style = "rq-button"}
				else
					local frame1 = current_frame.add{type="button", name = "rq-add"..v.name, caption = v.localised_name, style = background2}				
				end
			end
		end
	end
end

function any(array,value_in_array)
	local anyTrue = false
	for k,v in pairs(array) do
		if v[value_in_array] then anyTrue = true end
	end
	return anyTrue
end

function all(array,value_in_array)
	local allTrue = true
	for k,v in pairs(array) do
		if not v[value_in_array] then allTrue = false end
	end
	return allTrue
end

function matches(array,value_in_array,match_this)
	local matchFound = false
	for k1,v1 in pairs(array) do
		for k2,v2 in pairs(match_this) do
			
			if v1[value_in_array] == v2 then matchFound = true end
		end
	end
	return matchFound
end

function init()
	if global.researchQ == nil then global.researchQ = {} end
	if global.show_higher_tiers == nil then global.show_higher_tiers = {} end
	if global.showIcon == nil then global.showIcon = {} end
	if global.showResearched == nil then global.showResearched = {} end
	if global.offset == nil then global.offset = {} end
end

function player_init(player_index)
	game.players[player_index].gui.top.add{type="button", name="research_Q", caption="Research queue"}
	if global.researchQ[game.players[player_index].force.name] == nil then global.researchQ[game.players[player_index].force.name] = {} end
	global.show_higher_tiers[player_index] = false
	global.showIcon[player_index] = true
	global.showResearched[player_index] = false
	global.offset[player_index] = 0
end

script.on_configuration_changed(function(event)
	if event.mod_changes ~= nil and event.mod_changes["research-queue"] ~= nil and event.mod_changes["research-queue"].old_version == (nil or "1.0.0") then
		init()
		for k,v in pairs(game.players) do
			player_init(v.index)
		end
	end
end)
script.on_init(function()
	init()
end)

script.on_event(defines.events.on_gui_click, function(event)
	local player = game.players[event.player_index]
	if event.element.name == "research_Q" then
		if player.gui.center.Q then player.gui.center.Q.destroy()
		else
			local Q = player.gui.center.add{type="flow", name="Q", style="rq-flow"}
			local current_q = Q.add{type="frame", name="current_q", caption="Currrent queue", style="technology_preview_frame_style"}
			updateQ(player)
			local add2q = Q.add{type="frame", name="add2q", caption="Add to queue", style="technology_preview_frame_style", direction = "vertical"}	
			drawGrid(player)
		end
	
	elseif string.find(event.element.name,"rq-add",1,true) == 1 then
		local tech = string.gsub(event.element.name,"rq%-add","")
		add_research(player,tech)
		updateQ(player)
		drawGrid(player)
		for k,v in pairs(game.forces) do
			if not v.current_research and #global.researchQ[player.force.name] > 0 then
				v.current_research = global.researchQ[player.force.name][1]
			end
		end
	elseif string.find(event.element.name,"rqcancelbutton",1,true) == 1 then
		local tech = string.gsub(event.element.name,"rqcancelbutton","")
		remove_research(player,tech)
		updateQ(player)
		drawGrid(player)
	elseif string.find(event.element.name,"rqupbutton",1,true) == 1 then
		local tech = string.gsub(event.element.name,"rqupbutton","")
		up(player,tech)
		updateQ(player)
	elseif string.find(event.element.name,"rqdownbutton",1,true) == 1 then
		local tech = string.gsub(event.element.name,"rqdownbutton","")
		down(player,tech)
		updateQ(player)
	elseif event.element.name == "rqtext" then
		global.showIcon[player.index] = not global.showIcon[player.index]
		drawGrid(player)
	elseif event.element.name == "rqscience" then
		global.showResearched[player.index] = not global.showResearched[player.index]
		drawGrid(player)
	elseif event.element.name == "rqscrollup" then
		global.offset[player.index] = global.offset[player.index] - 1
		updateQ(player)
	elseif event.element.name == "rqscrolldown" then
		global.offset[player.index] = global.offset[player.index] + 1
		updateQ(player)		
	end
end)

script.on_event(defines.events.on_research_finished, function(event)
	if #global.researchQ[event.research.force.name] > 0 then
		for i,v in ipairs(global.researchQ[event.research.force.name]) do
			if v == event.research.name or game.forces[event.research.force.name].technologies[v].researched then
				table.remove(global.researchQ[event.research.force.name],i)
			end
		end
	end
	if #global.researchQ[event.research.force.name] > 0 then		
		game.forces[event.research.force.name].current_research = global.researchQ[event.research.force.name][1]
	end
	for k,v in pairs(event.research.force.players) do
		if v.gui.center.Q then 
			updateQ(v)
			drawGrid(v) 
		end
	end
end)

script.on_event(defines.events.on_player_created, function(event)
	player_init(event.player_index)
end)
